      real*4     function angle(x1,y1,z1,x2,y2,z2) ! in radians
c     ==== calculates angle between these two vectors [origin (0,0,0) ] ==== 
      real*4     x1,y1,z1, x2,y2,z2

      r1sq=x1*x1+y1*y1+z1*z1
      r1=sqrt(r1sq)
      if(r1.eq.0.0)print*,'angle ERROR: x1,y1,z1=',x1,y1,z1

      r2sq=x2*x2+y2*y2+z2*z2
      r2=sqrt(r2sq)
      if(r2.eq.0.0)print*,'angle ERROR: x2,y2,z2=',x2,y2,z2

      dot= x1*x2+y1*y2+z1*z2    ! dot product
      costh = dot/r1/r2
      if(costh.lt.-1.0)costh=-1.0
      if(costh.gt.1.0)costh=1.0

      angle= acos(costh)
      return
      end


      real*8     function angle8(x1,y1,z1,x2,y2,z2) ! in radians
c     ==== calculates angle between these two vectors [origin (0,0,0) ] ==== 
      real*8     x1,y1,z1, x2,y2,z2
      real*8     r1sq,r1,r2sq,r2, dot, costh

      r1sq=x1*x1+y1*y1+z1*z1
      r1=sqrt(r1sq)
      if(r1.eq.0.0d0)print*,'angle ERROR: x1,y1,z1=',x1,y1,z1

      r2sq=x2*x2+y2*y2+z2*z2
      r2=sqrt(r2sq)
      if(r2.eq.0.0d0)print*,'angle ERROR: x2,y2,z2=',x2,y2,z2

      dot= x1*x2+y1*y2+z1*z2    ! dot product
      costh = dot/r1/r2
      if(costh.lt.-1.0d0)costh=-1.0d0
      if(costh.gt.1.0d0)costh=1.0d0

      angle8= acos(costh)
      return
      end


      subroutine  xyz_rda8(x,y,z,r,del,alph)
      implicit real*8(a-h,o-z)
      real*8   x,y,z            !inputs (units imply units of  r )
      real*8   r,del,alph       !outputs (del in deg; alph in hours)

      parameter(pi_180= 3.14159265359/180.0) ! conversion deg -> rad
      parameter(pi180h= pi_180*15.0)       ! conversion hours -> rad
      
      print*,'xyz_rda8: WARNING: this version rounding unstable'

      rr=x*x+y*y+z*z
      if(rr.eq.0.0)then
         r=0.0
         del=99.9
         alph=99.9
      else
         r= sqrt(rr)
         
         del= asin(z/r) /pi_180
         
         alph= acos( x /r /sqrt(1.0-z*z/r/r) ) /pi180h
         if(y.lt.0)then
            alph= 24.0 - alph
         endif
      endif
      return
      end



      subroutine  xyz_rda_notoler(x,y,z,r,del,alph)
      implicit real*4(a-h,o-z)
      real*4   x,y,z            !inputs (units imply units of  r )
      real*4   r,del,alph       !outputs (del in deg; alph in hours)

      parameter(pi_180= 3.14159265359/180.0) ! conversion deg -> rad
      parameter(pi180h= pi_180*15.0)       ! conversion hours -> rad
      
      rr=x*x+y*y+z*z
      if(rr.eq.0.0)then
         r=0.0
         del=99.9
         alph=99.9
      else
         r= sqrt(rr)
         
         del= asin(z/r) /pi_180
         
         alph= acos( x /r /sqrt(1.0-z*z/r/r) ) /pi180h
         if(y.lt.0)then
            alph= 24.0 - alph
         endif
      endif
      return
      end







