c       ==== this file holds some basic, first principles, not necessarily
c       computationally efficient matrix operations =====

c        program testmat_8
        subroutine testmat_8
c       ==== tests matrix routines ====
        parameter(nmat=4)
        real*8   mat(nmat,nmat),inv(nmat,nmat),test(nmat,nmat)
        real*8   det4_8,cofact4_8
        real*8   det3_8,cofact3_8
        real*8   det2_8,cofact2_8
        real*8   det1_8,cofact1_8

        mat(1,1)=1.0
        mat(1,2)= -4.0
        mat(2,2)=2.0
        mat(1,3)=3.4
        mat(2,3)=9.0
        mat(3,1)=1.0
        mat(3,3)=2.0
        mat(3,4)=7.3
        mat(4,1)=-2.3
        mat(4,3)=6.7
        mat(4,4)=1.0

        print*,'matrix = '
        call printmat_8(mat,nmat,nmat)
        lev=0
        print*,'det4_8= ',det4_8(mat)
        print*,'end of first det4_8 calcn'

        call invert_8(mat,nmat,inv)
        print*,'inverse = '
        call printmat_8(inv,nmat,nmat)

        call mult_8(mat,inv,test,nmat,nmat,nmat,nmat)
        print*,' '
        print*,' product of the two is: '
        call printmat_8(test,nmat,nmat)
        end


        subroutine printmat_8(mat,m,n)
c       ============================
        integer*4  m,n
        real*8     mat(n,m)

        do i=1,m
            write(6,'(10g9.2)')(mat(j,i),j=1,n)
        enddo
        return
        end

        real*8  function det4_8(mat)
c       ==========================
        parameter(nmat=4,n=nmat)
        real*8      mat(nmat,nmat)
c        automatic j
        real*8      cofact4_8

        det4_8=0.0d0
        do j=1,n
           det4_8=det4_8+mat(j,1)*cofact4_8(mat,1,j)
        enddo

        return
        end

        real*8  function det3_8(mat)
c       ==========================
        parameter(nmat=3,n=nmat)
        real*8      mat(nmat,nmat)
c        automatic j
        real*8      cofact3_8

        det3_8=0.0d0
        do j=1,n
           det3_8=det3_8+mat(j,1)*cofact3_8(mat,1,j)
        enddo

        return
        end

        real*8  function det2_8(mat)
c       ==========================
        parameter(nmat=2,n=nmat)
        real*8      mat(nmat,nmat)
c        automatic j
        real*8      cofact2_8

c        det2_8=0.0d0
c        do j=1,n
c           det2_8=det2_8+mat(j,1)*cofact2_8(mat,1,j)
c        enddo

        det2_8= mat(1,1)*mat(2,2) - mat(1,2)*mat(2,1) ! faster calcn

        return
        end

        real*8  function det1_8(mat)
c       ==========================
        parameter(nmat=1,n=nmat)
        real*8      mat(nmat,nmat)
c        automatic j
        real*8      cofact1_8

        det1_8=mat(1,1)

        return
        end

        real*8  function cofact4_8(mat,i,j)
c       ================================
        integer*4  i,j
        parameter(nmat=4,n=nmat)
        real*8  mat(nmat,nmat)
c        automatic ia,ja
c        automatic adj
        real*8 adj(nmat-1,nmat-1)
        real*8 det3_8

c       ==== calculate cofactor A_ij= (-1)^{i+j} * det_8 M_ij ====
        do ia=1,i-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia)
            enddo
        enddo
        do ia=i,n-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia+1)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia+1)
            enddo
        enddo
        if(2*((i+j)/2).eq.i+j)then
            cofact4_8=det3_8(adj)
        else
            cofact4_8=-1.0*det3_8(adj)
        endif

        return
        end

        real*8  function cofact3_8(mat,i,j)
c       ================================
        integer*4  i,j
        parameter(nmat=3,n=nmat)
        real*8  mat(nmat,nmat)
c        automatic ia,ja
c        automatic adj
        real*8 adj(nmat-1,nmat-1)
        real*8 det2_8

c       ==== calculate cofactor A_ij= (-1)^{i+j} * det_8 M_ij ====
        do ia=1,i-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia)
            enddo
        enddo
        do ia=i,n-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia+1)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia+1)
            enddo
        enddo
        if(2*((i+j)/2).eq.i+j)then
            cofact3_8=det2_8(adj)
        else
            cofact3_8=-1.0*det2_8(adj)
        endif

        return
        end

        real*8  function cofact2_8(mat,i,j)
c       ================================
        integer*4  i,j
        parameter(nmat=2,n=nmat)
        real*8  mat(nmat,nmat)
c        automatic ia,ja
c        automatic adj
        real*8 adj(nmat-1,nmat-1)

c       ==== calculate cofactor A_ij= (-1)^{i+j} * det_8 M_ij ====
        do ia=1,i-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia)
            enddo
        enddo
        do ia=i,n-1
            do ja=1,j-1
                adj(ja,ia)=mat(ja,ia+1)
            enddo
            do ja=j,n-1
                adj(ja,ia)=mat(ja+1,ia+1)
            enddo
        enddo
        
        cofact2_8=adj(1,1)
        return
        end



        subroutine invert_8(mat,n,inv)
c       ============================
        parameter(nmat=4)
        real*8    mat(nmat,nmat),inv(nmat,nmat), x
        real*8    det4_8,cofact4_8
        real*8    det3_8,cofact3_8
        real*8    det2_8,cofact2_8

        if(n.gt.nmat)print*,'invert_8 ERROR: n,nmat=',n,nmat

        if(n.eq.4)then
           x=det4_8(mat)
        elseif(n.eq.3)then
           x=det3_8(mat)
        elseif(n.eq.2)then
           x=det2_8(mat)
        else
           x=mat(1,1)
        endif
        if(x.eq.0.0)then
           print*,'ERROR: determinant zero. Null matrix output.'
        else
           if(n.eq.1)then
              inv(1,1)=1.0/mat(1,1)
           else
              do i=1,n
                 do j=1,n
                    if(n.eq.4)then
                       inv(j,i)=cofact4_8(mat,j,i)/x
                    elseif(n.eq.3)then
                       inv(j,i)=cofact3_8(mat,j,i)/x
                    elseif(n.eq.2)then
                       inv(j,i)=cofact2_8(mat,j,i)/x
                    endif

c     ----   transpose of adjugate matrix for testing only ----
c     -             inv(j,i)=cofact4_8(mat,i,j)
c     -----
                 enddo
              enddo
           endif
        endif

        return
        end


      subroutine tran_8(mat,n,tran)
c     ============================
      parameter(nmat=4)
      real*8    mat(nmat,nmat),tran(nmat,nmat)
      do i=1,4
         do j=1,4
            tran(j,i)=mat(i,j)
         enddo
      enddo
      return
      end

         


        subroutine mult_8(a,b,c,ma,na,mb,nb)
c       ==== multiplies two matrices with ma, mb rows, na, nb columns;
c       with rows being the second fortran index and cols the first ====

        integer*4       ma,na,mb,nb
        real*8  a(na,ma),b(nb,mb),c(nb,ma)

c        print*,'mult: a,b'
c        call printmat(a,ma,na)
c        print*,'---------'
c        call printmat(b,mb,nb)
c        print*,'-------- '
        if(na.ne.mb)stop "matrix sizes don't match!!!!"

        do i=1,ma
            do j=1,nb
                c(j,i)=0.0
                do index=1,na
                    c(j,i)=c(j,i)+a(index,i)*b(j,index)
                enddo
            enddo
        enddo
c        print*,'mult: c'
c        call printmat(c,nb,ma)
c        print*,'------------end of mult:'

        return
        end
