c      program test 
      subroutine testmyline
c     ==== tests my line style subroutine ====
      parameter(n=15,npoints=50)
      real*4   y(npoints),x(npoints)

      call pgbegin(0, '?', 1, 1)
      call pgscf(2)
      call pgvsize(0.75, 7.25, 1.0, 6.25)
      call pgwindow(0.0,1.0,0.0,1.0)
      call pgbox('bcnts', 0., 0, 'bcntsv', 0., 0)
 
      do i=1,npoints
         x(i)=(real(i)-0.5)/real(npoints)
      enddo

      do isls=1,n
         do i=1,npoints
c            y(i)= (real(isls)-0.5)/real(n) * x(i) + 0.5 - 
c     _           (real(isls)-0.5)/3.0/real(n)
c            y(i)=  sin(x(i)*10.0)/4.0 + 0.28 +
c     _           0.6*real(isls)/real(n)
            if(i.le.isls)then
               y(i)=real(isls)/real(n)
            else
               y(i)=-99.9
            endif
         enddo
c         call pgtext(x(1),y(1),'testing')
         call myline(npoints,x,y,isls,1.0,1.0)
      enddo
      call pgend
      end


      subroutine myline(n,x,y,isls,xwidth,yheight)
c     ==== pgplot subroutine to draw lines of different styles ====
c     n, x, y   are as for  pgline( , , ); isls=line style (1,..,13);
c                    xwidth= |xmax-xmin|

      integer*4      n,isls, iold, isls2(4)
      real*4         x(*),y(*),xwidth,yheight

      integer*4      sym(8)
      real*4         chold, a,b, x1,y1, angle
c      real*4         xpl(1000)

      data  sym/2,5,4,6,7,11,12,14/
      data  isls2/1,2,4,3/

      call pgqch(qch)
      call pgqlw(iqlw)
      call pgsch(qch*real(iqlw))

c      chnew=1.0
      chnew= qch*sqrt(real(iqlw))
      delr=xwidth/100.0*chnew

      if(xwidth.le.0.0)print*,'myline- Warning: xwidth=',xwidth
      if(yheight.le.0.0)print*,'myline- Warning: yheight=',yheight

      if((1.le.isls).and.(isls.le.3))then
         call pgqls(iold)
         call pgsls(isls2(isls))
         call pgline(n,x,y)
         call pgsls(iold)
      elseif(4.le.isls.and.isls.le.12)then
         call pgqls(iold)
         call pgsls(1)
         ndash=(isls-1)/3
         ndot= isls -3*ndash
         interv= 4*ndash+ndot

c     ------ xpl(*) = points of dashes/dots; x(*) = data points ------
         xpl1=x(1)
         ipt=1
         th=atan((y(ipt+1)-y(ipt))/(x(ipt+1)-x(ipt)))
         xpl2= xpl1+ cos(th)*delr

         if(ipt2.eq.0)ipt2=1

c         do while(xpl(ipt2).lt.x(n))
c            ipt2=ipt2+1
c            xpl(ipt2)=x(1)+(real(ipt2)-1.0)*delx
c         enddo
c         npt2=ipt2
c         xpl(npt2)=x(n)
c     -------
         ipt2=1
         ipt=1
         do while(ipt.lt.n)
            a=(y(ipt+1)-y(ipt))/(x(ipt+1)-x(ipt))
            b=y(ipt) - a* x(ipt)
            costhold=costh
            costh=cos(atan(a*xwidth/yheight))
            do while(xpl1.lt.x(ipt+1))
               if(xpl1.le.x(ipt))then
                  if(ipt.eq.1)then
                     frac=0.0
                  else
                     frac=(x(ipt)-xpl1)/(costhold*delr)
                  endif
                  xpl2=x(ipt)+(1.0-frac)*costh*delr
               endif

               x1=max(xpl1,x(ipt))
               x2=min(xpl2,x(ipt+1))
               jint=ipt2-interv*(ipt2/interv)+1
               if(jint.le.4*ndash)then
                  if(4*(jint/4).ne.jint)then
                     call pgmove(x1,a*x1+b)
                     call pgdraw(x2,a*x2+b)
                  endif
               elseif(x1.eq.xpl1)then
                  call pgpoint(1,x1,a*x1+b,1)
               endif
               ipt2=ipt2+1
               xpl0=xpl1
               xpl1=xpl2
c               th=atan((y(ipt+1)-y(ipt))/(x(ipt+1)-x(ipt)))
               xpl2= xpl1+ costh*delr
            enddo
            ipt=ipt+1
            if(xpl1.gt.x(ipt))then
               ipt2=ipt2-1
               xpl2=xpl1
               xpl1=xpl0
            endif
         enddo
         if((xpl1.eq.x(ipt)).and.
     _        (ipt2-interv*(ipt2/interv)+1.gt.4*ndash))
     _        call pgpoint(1,xpl1,a*xpl1+b,1)

         call pgsls(iold)
      else
         print*,'No such line style: isls=', isls
      endif

      call pgsch(qch)

      return
      end
         

c               call pgpoint(1,x1,a*(x1-x(i))+b,sym(isls-5))

c               if(isls.eq.6)then
c                  if((ipt2/4)*4.eq.ipt2)then
c                     call pgptext(x1,y1,angle,0.5,'\\(0814)')
c                  elseif(((ipt2-2)/4)*4.eq.ipt2-2)then
c                     call pgptext(x1,y1,angle,0.5,'\\(0817)')
c                  endif
c               endif
