c     ==== subroutines for converting scanned figure, clicked
c     on using   saoimage.cursor.[.].region.write  ====
c     Univ Sussex note 13/9/95:  
c     (1a) use scanner to create image (e.g. .gif format) 
c     (1b) ftp the image to  astr (remember to  chmod go-w *  afterwards!)
c     (2) use  ~broukema/bin/xv  to convert to 
c     a   fits  format file (read in file, then   save   in fits format); 
c     [ or on star   /data/bfr/bin/xv_3.00 ]
c     (3)   saoimage -fits  myfigure.fts    (myfigure.fts =filename)
c     NB:  during following steps may swap between  cursor mode
c     and   pan  mode in order to move figure around; may also
c     increase size of window
c     (4) click on  cursor  button  to get into "cursor mode"
c     NB:  image coordinates are called   x, y;  data   p, q
c     (5a) click on four corners   (p1,q1), (p2,q1), (p1,q2), (p2,q2);
c     (5b) click on a point with negative   x  value  (at left of screen);
c     this is just a check
c     do is=1, nseries
c        (6) click on a series of points (of the is-th series you want);
c        (7) click on a point with negative  x value
c     enddo
c     (8) click on a negative  x  value to signal the end
c     (9) if you can't see a button   write  , (toggle) click the
c     region button to obtain a  write  button.  Use the write button,
c     which saves a text file  to a filename of your choice.
c     (10) write a calling programme like  testgetarr, compile it
c     linking with these subroutines, and run it: you'll enter
c     the astrophysical parameter values   p1, p2, q1, q2  and
c     end up with   ns  series of points in the arrays
c     _      pdat(1,is) to  pdat(np(is),is) and qdat(1,is) to  qdat(np(is),is)
c     from  is=1 to is=ns
c     (11) WARNING: make sure you properly reference use of others' data!!!


c     --- uncomment the "program" line and comment the subroutine line
c     if you want to use this simple test routine ----

c      program testgetarr
      subroutine testgetarr
c     ------------------
      parameter(maxdat=100,maxser=50) 
      real*4     pdat(maxdat,maxser),qdat(maxdat,maxser) 
      integer*4  np(maxser),ns  

      call getarrays(pdat,qdat,np,ns)
      end



      subroutine getarrays(pdat,qdat,np,ns)
c     ==== this routine reads in the  text  file written by saoimage

      character  infile*256, string*60, ch*1, outfile*256
      real*4     x1,y1,x2,y2, p1,p2,q1,q2
      parameter(maxdat=100,maxser=50) ! must be identical in calling routine
      real*4     xdat(maxdat,maxser),ydat(maxdat,maxser)
      real*4     pdat(maxdat,maxser),qdat(maxdat,maxser) ! output !!
      integer*4  np(maxser),ns  ! output !!

      write(6,'(a)')'Enter filename of output from '//
     _     'saoimage.cursor.[.].region.write: '
      read(5,'(a)')infile

      open(1,file=infile,access='sequential',form='formatted',
     _     status='old')

c     ---- read over header lines ----
      do i=1,3
         read(1,'(a)')string
         print*,string
      enddo

c     ---- read the four corners ---
      call readpt(x1a,y1a)
      call readpt(x2a,y1b)
      call readpt(x1b,y2a)
      call readpt(x2b,y2b)
      x1=(x1a+x1b)/2.0
      x2=(x2a+x2b)/2.0
      y1=(y1a+y1b)/2.0
      y2=(y2a+y2b)/2.0

      print*,'Read x1,x2,y1,y2 as: ',x1,x2,y1,y2
      call readpt(xx,yy)
      if(xx.ge.0.0)print*,'Warning: xx>=0: ',xx

c     ---- read in series of points ----
      is=0
      ip=1
      do while(ip.gt.0)
         ip=0
         is=is+1
         xx= 1.0
         do while(xx.gt.0.0)
            call readpt(xx,yy)
            if(xx.gt.0.0)then
               ip=ip+1
               xdat(ip,is)=xx
               ydat(ip,is)=yy
            endif
         enddo
         if(ip.gt.0)then
            np(is)= ip
            print*,'Read in ',np(is),' points of ',is,'-th series.'
         else
            is=is-1
         endif
      enddo
      ns=is

c     ---- read in astrophysical values of limits ----
      
      read(1,'(a)',end=77)string
      if(string(1:12).eq.'p1,p2,q1,q2=')then
         read(1,*)p1,p2,q1,q2
      else      
 77      continue
         print*,'string(1:12)=',string(1:12)
         write(6,'(a,$)')'Enter values   p1,p2, q1,q2: '
         read(5,*)p1,p2, q1,q2
         write(1,'(a12)')'p1,p2,q1,q2='
         write(1,*)p1,p2,q1,q2
         write(1,*)' '
      endif
      print*,'p1,p2,q1,q2= ',p1,p2, q1,q2
      close(1)

      pslope= (p2-p1)/(x2-x1)
      qslope= (q2-q1)/(y2-y1)
      print*,'pslope,qslope=',pslope,qslope


      do is=1,ns
         do ip=1,np(is)
            pdat(ip,is)= p1 + pslope*(xdat(ip,is)-x1)
            qdat(ip,is)= q1 + qslope*(ydat(ip,is)-y1)
         enddo
      enddo
      

      write(6,'(a,$)')'scanfig: Plot data? [Y] '
      read(5,'(a)')ch
      if((ch.ne.'n').and.(ch.ne.'N'))then
         pp1=p1
         pp2=p2
         qq1=q1
         qq2=q2
         print*,'pp1,pp2,qq1,qq2=',pp1,pp2,qq1,qq2
         write(6,'(a,$)')'Change? [N] '
         read(5,'(a)')ch
         if((ch.eq.'Y').or.(ch.eq.'y'))then
            write(6,'(a,$)')'Enter pp1,pp2,qq1,qq2: '
            read(5,*)pp1,pp2,qq1,qq2
         endif

         call pgbegin(0,'?',1,1)
         call pgsch(0.8)
         call pgscf(2)
         call pgvsize(1.0,5.0,1.0,5.0)
         call pgwindow(pp1,pp2,qq1,qq2)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsls(1)
         do is=1,ns
            call pgsls(mod(is,5))
            call pgline(np(is),pdat(1,is),qdat(1,is))
            call pglabel('p','q','scanned data')
         enddo
         call pgend
      endif

      write(6,'(a,$)')'scanfig: Print data numerically? [Y] '
      read(5,'(a)')ch
      if((ch.ne.'n').and.(ch.ne.'N'))then
         if(ns.gt.5)then
            print*,'(np(is),is=1,ns)=',(np(is),is=1,ns)
            write(6,'(a,$)')'Enter  npmax to use: '
            read(5,*)npmax
         endif

         print*,'list of pdat '
         do is=1,ns
            if(ns.le.5)
     _           print*,'****** is, np(is) =',is,np(is),' ******'
            i=0
            if(ns.le.5)print*,'pdat: '
            do while(i.lt.np(is))
               ii=i+1
               i=min(i+5,np(is))
               write(6,'(a6,5(f9.3,a2))')
     _              '     _',(pdat(ip,is),', ',ip=ii,i)
            enddo
            write(6,'(a6,i4,a6)')
     _           '     _', npmax-np(is),'*-99.9'
         enddo
         print*,'list of qdat '
         do is=1,ns
            i=0
            if(ns.le.5)print*,'qdat '
            do while(i.lt.np(is))
               ii=i+1
               i=min(i+5,np(is))
               write(6,'(a6,5(f9.3,a2))')
     _              '     _',(qdat(ip,is),', ',ip=ii,i)
            enddo
            write(6,'(a6,i4,a6)')
     _           '     _', npmax-np(is),'*-99.9'
         enddo
      endif

      write(6,'(a,$)')'scanfig: Print data to binary file? [Y] '
      read(5,'(a)')ch
      if((ch.ne.'n').and.(ch.ne.'N'))then
         write(6,'(a,$)')'Enter filename: '
         read(5,'(a)')outfile
         open(1,file=outfile,access='sequential',form='unformatted',
     _        status='unknown')
         write(1)ns,(np(is),is=1,ns)
         write(1)((pdat(i,is),i=1,np(is)),is=1,ns)
         write(1)((qdat(i,is),i=1,np(is)),is=1,ns)
         close(1)
      endif

      return
      end



      subroutine readpt(x,y)
      real*4  x,y
      character    string*20
      

      read(1,'(a)')string
      if(string(1:7).ne.' POINT(')then
         print*,'Error reading file '
         print*,'Have read in: ',string
         return
      endif

      i1=8
      if(string(i1:i1).eq.'-')then
         sign=-1.0
      else
         sign=1.0
      endif
      do while(string(i1:i1).ne.',')
         i1=i1+1
      enddo
      read(string(8:i1-1),*)x

      i2=i1+1
      do while(string(i2:i2).ne.')')
         i2=i2+1
      enddo
      read(string(i1+1:i2-1),*)y
      print*,'POINT(',x,',',y,')'

      return
      end
