c      program testscramble
      subroutine testscramble

      real*4  x(30),y(30)
      integer*4  ix(30)

      do i=1,30
         x(i)=real(i)/10.0  ! i  !
      enddo
c      call scramble(30,x,y)

      call smoothdNdz(30,0.5,0.3,x,y)

      do i=1,30
         ix(i)=nint(y(i)*10.0)
      enddo
      print*,'x=',x
c      write(6,'(a,30i3)')'ix=',ix

      do i=1,30
         print*,'ix=',ix(i)
      enddo

      end


      subroutine scramble(maxn,xin,xout)
C     ==== randomly permutes the values in xin and puts them in xout ====
C     - the set of values out is identical (as a set) to the set fed in -

      integer*4 maxn
      real*4    xin(*),xout(*) ! these must be at least as big as maxn

      parameter(maxnbig=100000) ! this must be at least as big as maxn
      real*4    rindex(maxnbig)
      integer*4 index(maxnbig)

      integer*4 ifirst
      save      ifirst

      if(maxn.lt.1)return
      if(maxn.gt.maxnbig)then
         print*,'scramble.f ERROR: maxn,maxnbig=',maxn,maxnbig
         print*,'please modify and recompile.'
         pause
      endif

      if(ifirst.ne.12345)then
         print*,'Starting  scramble...'
c         ifirst=12345
         nflush=238719          !234127
         do i=1,nflush
            xyz=randt()
         enddo
      endif
      
      do iq=1,maxn
         rindex(iq)=randt()
         index(iq)=iq
      enddo
      call risort(maxn,rindex,index)

      do iq=1,maxn
         xout(iq)=xin(index(iq))
      enddo

      if(ifirst.ne.12345)then
         print*,'Done first scramble...'
         ifirst=12345
      endif

      return
      end




      subroutine smoothdNdz(maxn,zmin,zsm,zin,zout)
C     ==== based on values in zin, puts smoothed version in zout ====
C     The smoothed version is in a pseudo-random order.
C     Non-positive redshifts are not generated.

C     INPUTS:
      integer*4 maxn
      real*4    zmin,zsm        ! min z and smoothing half-width
      real*4    zin(*)  ! these must be at least as big as maxn

C     OUTPUTS:
      real*4    zout(*)  ! these must be at least as big as maxn

C     INTERNAL:
      parameter(maxnbig=100000) ! this must be at least as big as maxn
      real*4    rindex(maxnbig)
      integer*4 index(maxnbig)

      logical*4 test

      parameter(mxbins=100)
      real*4        zb(mxbins),dN(mxbins),dNsmoo(mxbins)
      parameter(pi=3.14159265359)

      integer*4 ifirst
      save      ifirst

      data  test /.false./ !.true./ !


      if(maxn.lt.1)return
      if(maxn.gt.maxnbig)then
         print*,'smoothdNdz.f ERROR: maxn,maxnbig=',maxn,maxnbig
         print*,'please modify and recompile.'
         pause
      endif

      if(ifirst.ne.12345)then
         print*,'Starting  smoothdNdz...'
         ifirst=12345
         nflush=238719          !234127
         do i=1,nflush
            xyz=randt()
         enddo
      endif

      ioob=20
c      zmax=5.0
      zmax=-9e9
      do iq=1,maxn
         zmax=max(zmax,zin(iq))
      enddo
      if(test)print*,' smoothdNdz: zmax=',zmax

      nbins=100
      call mkbins(maxn,0.0,zmax, zin, nbins,
     _     zb,bmin,bmax, dN, ioob)
      
c      ismoo=2 ! ismoo=2 => 2/100 * 5.0
      ismoo=nint( zsm /(zmax/real(nbins)) )
      ismoo=max(1,ismoo)
      fact=1.0/sqrt(2.0*pi) /real(ismoo)
      
      dNmax=-9e9
      dNmaxsm=-9e9
      do i=1,nbins
         dNsmoo(i)=0.0
         do j=max(1,i-2*ismoo),min(i+2*ismoo,nbins) ! -> 2 sigma
            dd= real(j-i)
            xx= exp(-0.5*dd*dd/real(ismoo*ismoo))
            dNsmoo(i)=dNsmoo(i)+ xx*dN(j)   
         enddo
         dNmax=max(dNmax,dN(i))

         dNsmoo(i)=dNsmoo(i)*fact 
         dNmaxsm=max(dNmaxsm,dN(i))

      enddo
      if(test)print*,'smoothdNdz: dNmax=',dNmax,' dNmaxsm=',dNmaxsm

c      nflush=238719!234127
c      do i=1,nflush
c         xyz=randt()
c      enddo
      
      if(test)print*,'smoothdNdz: maxn=',maxn

      dz= zb(2)-zb(1)
      if(abs(dz).lt.1e-4)print*,'smoothdNdz Error: dz=',dz

      do iq=1,maxn
         jtry=0
         izz=1
         dd=1e9
         do while(jtry.lt.100.and.dd.gt.dNsmoo(izz))
            jtry=jtry+1
            zz=zmin+ randt()*(zmax-zmin)
            izz= max(1, min(nbins, int(zz/dz)))
            dd=randt()*dNmaxsm
         enddo
         if(dd.gt.dNsmoo(izz))print*,'smoothdNdz WARNING: ',
     _        'jtry,zz,izz,dd,dNsmoo(izz)=',
     _        jtry,zz,izz,dd,dNsmoo(izz)

c         ddz= (randt() -0.5)*dz 

c         zout(iq)=max(0.002, zb(izz) + ddz)
c         zout(iq)=max(0.002, zz)  ! modif 02/11/99 -> check OK. Yes OK.

         zout(iq)= zz
      enddo

      print*,'Done smoothdNdz.'
      return
      end

