c      program testsphharm
      subroutine testsphharm
c     ==== test routines for spherical harmonics ====
      parameter(pi=3.1415926535898)

      complex  ylmfn,almfn, junkfn
      external ylmfn,almfn, junkfn
      real     plgndr,factrl
      external plgndr,factrl

      integer  lt,mt
      common /testcomm/ lt,mt
      complex  cc
      
      nresol=100

      print*,'conjg((1,2)),conjg((0,1)),conjg((1,0))='
      print*,conjg((1,2)),conjg((0,1)),conjg((1,0))
      print*,'real((1,2)),real((0,1)),real((1,0))='
      print*,real((1,2)),real((0,1)),real((1,0))
      print*,'imag((1,2)),imag((0,1)),imag((1,0))='
      print*,imag((1,2)),imag((0,1)),imag((1,0))

      do lt=0,3
         do lt2=0,3
c            cc= ylmfn(lt,mt, 0.0,-pi/4)
c            print*,'lt,mt,ylmfn(lt,mt,0.0,-pi/4)=',lt,mt,cc
c            cc= conjg(cc)*cc *pi
c            print*,'___________________________',
c     _           'conjg(cc)*cc *pi=',cc

            do mt=-lt,lt
               do mt2=-lt2,lt2
                  cc= almfn(lt2,mt2,nresol,junkfn)
                  if(abs(cc).gt.1e-7)
     _                 print*,'lt,lt2,mt,mt2,cc=',
     _                 lt,lt2,mt,mt2,cc
               enddo
            enddo
         enddo
      enddo

      end

      complex function junkfn(phi,theta)
      integer  lt,mt
      common /testcomm/ lt,mt

      complex   ylmfn
      external  ylmfn

      junkfn=ylmfn(lt,mt,phi,theta)
      return
      end



      complex  function ylmfn(l,m,phi,theta) ! in radians
      integer*4   l,m
      real*4      phi,theta  ! theta \in (-pi/2,pi/2), phi \in (0,2pi)

c     Internal:
      parameter(maxl=30,maxm=maxl)
      real*4      first,fact(-maxm:maxm,0:maxl)
      parameter(pi=3.1415926535898)

      complex     cc

      save        first,fact
      
      mabs=abs(m)
      if(mabs.gt.l)then
         print*,'ylmfn: Error: mabs,l=',mabs,l
      endif
      if(first.ne.1234.5)then
         first=1234.5
         do il=0,maxl
            do imabs=0,il
               fact(imabs,il)= sqrt( (2.0*real(il)+1)/(4.0*pi) 
     _              *factrl(il-imabs)/factrl(il+imabs) )
            enddo
         enddo
      endif

c     ctheta=cos(theta)         ! SH convention  0 < th < pi 
      cthSH= - sin(theta)       ! use astro convention -pi/2 < th < pi/2
      
      cc =  cmplx(fact(mabs,l)* plgndr(l,mabs,cthSH))
     _     *exp( (0,1)* cmplx(mabs)* phi )

      if(m.lt.0)then
         if(2*(m/2).eq.m)then !even m
            ylmfn= conjg(cc)
         else
            ylmfn= - conjg(cc)
         endif
      else
         ylmfn= cc
      endif

      return
      end

      complex function almfn(l,m,nresol,func)
      complex   func,ylmfn
      external  func   ! func(phi,theta) for which to find almfn values
c     -                ! theta \in (-pi/2,pi/2), phi \in (0,2pi)
      external  ylmfn
      
      integer   l,m  
      integer   nresol          ! resolution for double integral
      parameter(pi=3.1415926535898)
      
c     Internal:
c      parameter(maxn=1000)
      complex   cc

      th1=-pi/2
      th2=pi/2
      ph1=0.0
      ph2=2.0*pi
      dth=(th2-th1)/real(nresol)
      dph=(ph2-ph1)/real(2*nresol)

      cc=0.0
      do ith=1,nresol
         theta= th1+(real(ith)-0.5)*dth
         do iph=1,2*nresol
            phi= ph1+(real(iph)-0.5)*dph
            cc=cc + cmplx(cos(theta)) * conjg(ylmfn(l,m,phi,theta))
     _           * func(phi,theta)
         enddo
      enddo
      cc=cc *cmplx(dth*dph)
      
      almfn= cc
      return
      end

