      subroutine  xyz_rda(x,y,z,r,del,alph)
      real*4   x,y,z            !inputs (units imply units of  r )
      real*4   r,del,alph       !outputs (del in deg; alph in hours)

      parameter(pi_180= 3.14159265359/180.0) ! conversion deg -> rad
      parameter(pi180h= pi_180*15.0)       ! conversion hours -> rad
      
      parameter(tol=1e-5)

      rr=x*x+y*y+z*z
      if(rr.eq.0.0)then
         r=0.0
         del=99.9
         alph=99.9
      else
         r= sqrt(rr)
         zonr=z/r
c     ---- warnings added 23/06/99 ----
         if(zonr.gt.1.0-tol)then
            if(zonr.gt.1.0+10*tol)then
               print*,'xyz_rda WARNING: zonr=',zonr,
     _              ' x,y,z=',x,y,z
            endif
            zonr=1.0-tol
         elseif(zonr.lt.-1.0+tol)then
            if(zonr.lt.-1.0-10*tol)then
               print*,'xyz_rda WARNING: zonr=',zonr,
     _              ' x,y,z=',x,y,z
            endif
            zonr=-1.0+tol
         endif
         
c         del= asin(z/r) /pi_180
         del= asin(zonr) /pi_180
         
         cos2th=1.0-z*z/(r*r)
         if(cos2th.lt.tol)then
            alph=9.99           !  arbitrary r.a. since close to NP or SP
         else
            cosalph= x /r /sqrt(cos2th)
            if(cosalph.gt.1.0-tol)then
               if(cosalph.gt.1.0+10*tol)then
                  print*,'xyz_rda WARNING: cosalph=',cosalph,
     _                 ' x,y,z=',x,y,z
               endif
               cosalph=1.0-tol
            elseif(cosalph.lt.-1.0+tol)then
               if(cosalph.lt.-1.0-10*tol)then
                  print*,'xyz_rda WARNING: cosalph=',cosalph,
     _                 ' x,y,z=',x,y,z
               endif
               cosalph=-1.0+tol
            endif

            alph= acos(cosalph) /pi180h
            if(y.lt.0)then
               alph= 24.0 - alph
            endif
         endif
      endif
      return
      end

      function ixm(a)
      b=abs(a)
      ixm= int( (b-int(b))*60.0 )
      return
      end

      function xs(a)
      b=abs(a)*60.0
      xs= (b-int(b))*60.0
      return
      end
